#!/usr/bin/perl

#####################
## QUOTER          ##
## VERSION : 0.04  ##
## ReneGade/TiS    ##
## bkarak@unipi.gr ##
## 28/6/2000       ##
#####################

# choose one random quote file
# c_decl -> int choose_file(int numbFiles)
sub choose_file{
	return time() % $_[0];
}

# trim the spaces from one STRING
# c_decl -> char *trim(char *)
sub trim{
	$_[0] =~ s/\n/ /;
	$_[0] =~ s/ //;
	return $_[0];
}

# dgebug info
sub debug_info{
	print "FILE -> ".$filename."\n";
	print "MAX_QUO -> ".$numba."\n";
	print "HTML_FILE -> ".$html_filename."\n";
	print "SELECTED -> ".$selected."\n";
}

# append to html
sub append_html{
	open(htmlFp,$html_filename) or print "ERROR cannot open. HTML_FILE PARAMETER ERROR".$html_filename;
	while(<htmlFp>){
		if(/$QUOTE_MARK/){
			print $_[0];
		}
		else{
			print;
		}
	}
	close(htmlFp);
}

## MAIN PROGRAM

####################################
#configuration Variables           #
####################################

# configuration parameters
$CONFIG_FILE = "quoter.conf";
$QUOTE_MARK = "<!-- quote -->";
$EXTRA_HTML = "<br>";

# options
$APPEND_EXTRA_HTML = 1;	# 0 do not append <br> between each quote line,1 append
$DEBUG = 0; 		# 0 no debug output,1 debug output

# main program
open(fp_conf,"$CONFIG_FILE");
@configFile = <fp_conf>;
close(fp_conf);
if(scalar(@configFile) != 1){
	$quote_file = choose_file(scalar(@configFile));
}else{
	$quote_file = 0;
}
@conf_array = split(/@@/,@configFile[$quote_file]);
$file = trim(@conf_array[0]);
$quo_no = trim(@conf_array[1]);
$html_file = trim(@conf_array[2]);
($tmp,$filename) = split(/=/,$file);
($tmp,$numba) = split(/=/,$quo_no);
($tmp,$html_filename) = split(/=/,$html_file);
$filename = trim($filename);
$numba = trim($numba);
$html_filename = trim($html_filename);
open(fp_quote,"$filename");
$counter = 1;
$selected = (time() % $numba) + 1;
if($DEBUG == 1){ debug_info(); }
$quote_desc = <fp_quote>;
$quote_desc = trim($quote_desc);
while($line = <fp_quote>){
	if($line =~ /$quote_desc/){ $counter++;next; }
	if($counter == $selected){
		$theQuote = $theQuote.$line;
		if($APPEND_EXTRA_HTML == 1){ $theQuote = $theQuote.$EXTRA_HTML; }
	}
	if($counter > $selected){ break; }
}
close(fp_quote);
append_html($theQuote);
